## START: Set by rpmautospec
## (rpmautospec version 0.6.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 3;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Generated by rust2rpm 25
%bcond_without check

Name:           rustup
Version:        1.26.0
Release:        %autorelease
Summary:        Manage multiple rust installations with ease

SourceLicense:  MIT OR Apache-2.0
# (Apache-2.0 OR MIT) AND BSD-3-Clause
# (MIT OR Apache-2.0) AND Unicode-DFS-2016
# 0BSD OR MIT OR Apache-2.0
# Apache-2.0
# Apache-2.0 OR BSL-1.0
# Apache-2.0 OR ISC OR MIT
# Apache-2.0 OR MIT
# Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT
# ISC
# ISC AND MIT AND OpenSSL
# MIT
# MIT OR Apache-2.0
# MIT OR Apache-2.0 OR Zlib
# MIT OR Zlib OR Apache-2.0
# Unlicense OR MIT
# Zlib OR Apache-2.0 OR MIT
License:        Apache-2.0 AND BSD-3-Clause AND ISC AND MIT AND OpenSSL AND Unicode-DFS-2016 AND (0BSD OR MIT OR Apache-2.0) AND (Apache-2.0 OR BSL-1.0) AND (Apache-2.0 OR ISC OR MIT) AND (Apache-2.0 OR MIT) AND (Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT) AND (MIT OR Apache-2.0 OR Zlib) AND (Unlicense OR MIT)
# LICENSE.dependencies contains a full license breakdown

URL:            https://github.com/rust-lang/rustup
Source:         %{url}/archive/%{version}/rustup-%{version}.tar.gz

# non-upstreamable patches:
# * drop Windows-specific dependencies
Patch:          0001-Drop-Windows-specific-dependencies.patch
# * drop unavailable "openssl/vendored" feature
Patch:          0002-Drop-feature-for-statically-linking-against-vendored.patch
# * bump "term" dependency from 0.5.1 to 0.7 (blocked upstream)
Patch:          0003-Bump-term-dependency-from-0.5.1-to-0.7.patch
# * remove unused tracing support and unnecessary "rs_tracing" dependency
Patch:          0004-Remove-unused-tracing-support.patch
# * remove unused git-based versioning and unnecessary "git-testament" dependency
Patch:          0005-Remove-unused-git-based-versioning.patch

# rustup is only fully functional on Rust "Tier 1" architectures
ExclusiveArch:  x86_64 aarch64

BuildRequires:  cargo-rpm-macros >= 24

%global _description %{expand:
Manage multiple rust installations with ease.}

%description %{_description}

%prep
%autosetup -n rustup-%{version} -p1
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires

%build
%cargo_build -f no-self-update
%{cargo_license_summary -f no-self-update}
%{cargo_license -f no-self-update} > LICENSE.dependencies

%install
%cargo_install -f no-self-update

# generate and install shell completions
cp -pav target/rpm/rustup-init target/rpm/rustup
target/rpm/rustup completions bash > rustup.bash
target/rpm/rustup completions fish > rustup.fish
target/rpm/rustup completions zsh > _rustup

install -Dpm 0644 rustup.bash -t %{buildroot}/%{bash_completions_dir}
install -Dpm 0644 rustup.fish -t %{buildroot}/%{fish_completions_dir}
install -Dpm 0644 _rustup -t %{buildroot}/%{zsh_completions_dir}

%if %{with check}
%check
# * skip tests that require internet access
# * skip tests for the "rustup" binary that is not built in this package
%cargo_test -- -- --skip suite::cli_exact::check_updates --skip suite::cli_ui::rustup_ui_doc_text_tests
%endif

%files
%license LICENSE-APACHE
%license LICENSE-MIT
%license LICENSE.dependencies
%doc CHANGELOG.md
%doc CONTRIBUTING.md
%doc README.md

%{_bindir}/rustup-init

%{bash_completions_dir}/rustup.bash
%{fish_completions_dir}/rustup.fish
%{zsh_completions_dir}/_rustup

%changelog
## START: Generated by rpmautospec
* Thu May 23 2024 Fabio Valentini <decathorpe@gmail.com> - 1.26.0-3
- Rebuild with Rust 1.78 to fix incomplete debuginfo and backtraces

* Sat Jan 27 2024 Fedora Release Engineering <releng@fedoraproject.org> - 1.26.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Thu Nov 30 2023 Fabio Valentini <decathorpe@gmail.com> - 1.26.0-1
- Initial import (#2251579)
## END: Generated by rpmautospec
